#!/usr/bin/perl

use DBI;
use CGI qw(:standard escape unescape escapeHTML unescapeHTML);

require '/somewhere/bboard-param.pl';

my $CGIname = 'bboard.cgi';
my $Offset = 0;
my $Limit = 20;

my $mydb = DBI->connect("DBI:mysql:$DB:$Server", $User, $Passwd);
my $cgi = new CGI;
my $form = undef;
my $offset = $cgi->param('offset') ? $cgi->param('offset') : $Offset ;
my $limit = $cgi->param('limit') ? $cgi->param('limit') : $Limit ;

my $ID = $ENV{'REMOTE_USER'};

# 顼
#
sub error {
  my ($msg,$url)=@_;
  print <<EEE;
Content-Type: text/html; charset=euc-jp

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN">
<html>
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=euc-jp">
    <title>Ǽ</title>
  </head>

  <body bgcolor="white">
    <h1>Ǽ</h1>
    <p>
    $msg
EEE
if ($url) { print "<br><a href=\"$url\"></a>\n"; }
print <<EEE;
    </p>
  </body>
</html>
EEE
  exit;
}

# ɽURLذư
#
sub redirect {
  my ($host,$script,$url);
  $host = $ENV{'SERVER_NAME'};
  $script = $ENV{'SCRIPT_NAME'};
  $url = "http://${host}${script}?action=list&offset=${offset}&limit=${limit}";
  print <<EEE;
Status: 302 Found
Location: $url
Content-Type: text/html

<html><body>
<a href="$url">Continue</a>
</body></html>
EEE
  exit;
}

# åϿե
#
sub make_message_form {
  my($subject, $content) = @_;
  my($s,$c,$form);
  $s = escapeHTML($subject);
  $c = escapeHTML($content);
  $form = <<EEE;
    <table border=5 cellpadding=10 width="100%"><tr><td bgcolor="#80e080">
    <form method="post" action="$CGIname">
      <input type="hidden" name="action" value="confirm">
      <input type="hidden" name="offset" value="$offset">
      <input type="hidden" name="limit" value="$limit">
EEE
  if (not $ID) {
      $form .= <<EEE2;
      ID:<input type="text" name="id" size=10>
      ѥ:<input type="password" name="passwd" size=10><br>
EEE2
  }
  $form .= <<EEE3;
      ̾:<input type="text" name="subject" size=80 value="$s"><br>
      :<br>
      <textarea cols=80 rows=15 name="content">$c</textarea><br>
      <input type="submit" value="ǧ">&nbsp;
      <input type="reset" value="ꥢ">
    </form>
    </td></tr></table><br>
EEE3
  return $form;
}

# Ͽǧե
#
sub make_confirm_form {
  my ($id, $passwd, $subject, $content)=@_;
  my ($name, $email, $form, $sth);
  my $s = $mydb->quote($id);
  $sth = $mydb->prepare("SELECT name,email FROM member WHERE id='$id'");
  $sth->execute;
  ($name, $email) = $sth->fetchrow_array;
  $id = escapeHTML($id);
  $passwd = escapeHTML($passwd);
  $subject = escapeHTML($subject);
  $content = escapeHTML($content);
  $email = escapeHTML($email);
  $name = escapeHTML($name);
  $form = <<EEE;
    <table border=5 cellpadding=10 width="100%"><tr><td bgcolor="#ff8080">
    <h2>Ƴǧ</h2>
    <form method="post" action="$CGIname">
    <input type="hidden" name="action" value="entry">
    <input type="hidden" name="offset" value="$offset">
    <input type="hidden" name="limit" value="$limit">
    <input type="hidden" name="id" value="$id">
    <input type="hidden" name="passwd" value="$passwd">
    <input type="hidden" name="subject" value="$subject">
    <input type="hidden" name="content" value="$content">
    <table border=1 cellspacing=0 width="100%">
      <tr>
        <td bgcolor="#e0e0ff">
          [*] $subject<br>
          0000-00-00 00:00: [$id] <a href="mailto:$email">$name</a>
        </td>
      </tr>
      <tr>
        <td bgcolor="#ffffff">
          <pre>$content</pre>
        </td>
      </tr>
    </table>
    <input type="submit" value="Ͽ">
    </form>
    </td></tr></table>
EEE
  return $form;
}

# IDå
#
sub check_id {
  my($id, $url) = @_;
  my $sth = $mydb->prepare("SELECT 1 FROM member WHERE id='$id'");
  $sth->execute;
  if ($sth->rows == 0) {
    error (' ID ϲϿƤޤ', $url);
  }
}

# ID/ѥɥå
#
sub check_passwd {
  my ($id, $passwd, $url)=@_;
  my ($sth, $idq,$pq);
  $idq = $mydb->quote($id);
  $pq = $mydb->quote($passwd);
  $sth = $mydb->prepare("SELECT 1 FROM member WHERE id=$idq AND passwd=$pq");
  $sth->execute;
  if ($sth->rows == 0) {
    error ('ѥɤְäƤޤ', $url);
  }
  $sth->finish;
}

# åɽ
#
sub show_message {
  my ($number, $id2, $name, $email, $timestamp, $subject, $content, $del)=@_;
  if ($del) {
    $content = '*** ΥåϺޤ ***';
  }
  $name = escapeHTML($name);
  $email = escapeHTML($email);
  $content = escapeHTML($content);
  my $html = <<EEE;
    <table border=1 cellspacing=0 width="100%">
      <tr>
	<td bgcolor="#e0e0ff">
	  [$number] $subject<br>
	  $timestamp: $id2 <a href="mailto:$email">$name</a>
	</td>
      </tr>
      <tr>
	<td bgcolor="#ffffff">
	  <pre>$content</pre>
	</td>
      </tr>
      <tr>
	<td bgcolor="#ffe0e0">
	  <a href="$CGIname?action=reply&num=${number}&offset=${offset}&limit=${limit}">[Ѥ]</a>
EEE
  if (not $ID  ||  $ID eq $id2) {
    my $s = $del ? 'undel' : 'delete';
    my $s1 = $del ? '' : '';
    $html .= <<EEE;
	  <a href="${CGIname}?action=${s}&num=${number}&offset=${offset}&limit=${limit}">[$s1]</a>
EEE
  }
  $html .= <<EEE;
	</td>
      </tr>
    </table>
    <br>
EEE
}

############## MAIN ################
my ($action, $num, $sth, $subject, $content, $id2, $passwd, $del, $req, $mes);
my ($idq, $subjectq, $contentq, $numq);
if ($cgi->param('action'))
{
  $action = $cgi->param('action');

  # ɽ
  if ($action eq 'list') {
    # Ǥϲ⤷ʤ
  }
  # 
  elsif ($action eq 'new') {
    $form = make_message_form('','');
  }
  # Ѥ
  elsif ($action eq 'reply') {
    $num = $cgi->param('num');
    $sth = $mydb->prepare("SELECT subject,content FROM message WHERE number='$num'");
    $sth->execute;
    ($subject, $content) = $sth->fetchrow_array;
    $content =~ tr/^/> /;
    $content = "[${num}: ${subject}] Фֻ\n\n" . $content;
    $subject = 'Re: ' . $subject if ($subject =~ /^re:/i);
    $form = make_message_form($subject, $content);
    $sth->finish;
  }
  # Ƴǧ
  elsif ($action eq 'confirm') {
    if ($ID) {
      $id2 = $ID;
      $passwd = '';
      check_id($id2);
    }
    else {
      $id2 = $cgi->param('id');
      $passwd = $cgi->param('passwd');
      check_passwd($id2, $passwd);
    }
    $subject = $cgi->param('subject');
    $subject =~ tr/\t\n/ /;
    $content = $cgi->param('content');
    $form = make_confirm_form($id2, $passwd, $subject, $content);
  }
  # Ͽ
  elsif ($action eq 'entry') {
    if ($ID) {
      $id2 = $ID;
      check_id($id2);
    }
    else {
      $id2 = $cgi->param('id');
      check_passwd($id2, $cgi->param('passwd'));
    }
    $subject = $cgi->param('subject');
    $subject =~ tr/\t\n/ /;
    $content = $cgi->param('content');
    $idq = $mydb->quote($id2);
    $subjectq = $mydb->quote($subject);
    $contentq = $mydb->quote($content);
    $sth = $mydb->prepare("INSERT INTO message (id,subject,content) VALUES ($idq,$subjectq,$contentq)");
    $sth->execute;
    $sth->finish;
    redirect();
  }
  #  or 
  elsif ($action eq 'delete' || $action eq 'undel') {
    $num = $cgi->param('num');
    if ($action eq 'delete') {
      $del = 'y';
      $req = 'delete';
      $mes = "ֹ $num Υåޤ";
    }
    else {
      $del = 'n';
      $req = 'undel';
      $mes = "ֹ $num Υåκäޤ";
    }

    if ($ID) {
      $numq = $mydb->quote($num);
      $idq = $mydb->quote($ID);
      $sth = $mydb->prepare("UPDATE message SET del='$del' WHERE number=$numq AND id=$idq");
      $sth->execute;
      $sth->finish;
      redirect();
    }

    if ($cgi->param('passwd')) {
      $numq = $mydb->quote($num);
      $sth = $mydb->prepare( "SELECT id FROM message WHERE number=$numq");
      $sth->execute;
      my @a = $sth->fetchrow_array;
      $id2 = $a[0];
      $sth->finish;
      check_passwd($id2, $cgi->param('passwd'), "${CGIname}?action=${req}&num=${num}&offset=${offset}&limit=${limit}");
      $idq = $mydb->quote($id2);
      $sth = $mydb->prepare("UPDATE message SET del='$del' WHERE number=$numq AND id=$idq");
      $sth->execute;
      $sth->finish;
      redirect();
    }

    $form = <<EEE;
    <table border=5 cellpadding=10 width="100%"><tr><td bgcolor="#ff8080">
    $mes<br>
    <form method="post" action="${CGIname}">
      <input type="hidden" name="action" value="${req}">
      <input type="hidden" name="offset" value="${offset}">
      <input type="hidden" name="limit" value="${limit}">
      <input type="hidden" name="num" value="${num}">
      ѥ:<input type="password" name="passwd" size=10><br>
      <input type="submit" value="">
    </form>
    </td></tr></table><br>
EEE
  }
  else {
    die "unkown action '$action'";
  }

}

print <<EEE;
Content-Type: text/html; charset=euc-jp

<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0//EN">
<html>
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=euc-jp">
    <title>Ǽ</title>
  </head>

  <body bgcolor="#fffff0">
    <h1>Ǽ $ID</h1>

    <p><a href="${CGIname}?action=new&offset=${offset}&limit=${limit}">[]</a></p>
EEE

if ($form) { print $form; }

$sth = $mydb->prepare( 'SELECT max(number), min(number) FROM message');
$sth->execute;
my ($max, $min) = $sth->fetchrow_array;
$sth->finish;

$sth = $mydb->prepare( "SELECT number, message.id, name, email, DATE_FORMAT(timestamp, \"%Y-%m-%d %H:%i\"), subject, content, del FROM message LEFT JOIN member USING (id) ORDER BY number DESC LIMIT ${offset},${limit}");
my $numrows = $sth->execute;
my $res = $sth->fetchall_arrayref;
my $first = $res->[0][0];
my $last = $res->[$numrows-1][0];

my $next_prev = "    <p>";
if ($max > $first) {
  my $of = $offset - $limit;
  if ($of < 0) { $of = 0; }
  $next_prev .= "<a href=\"${CGIname}?action=list&offset=${of}&limit=${limit}\">[]</a>";
}
if ($min < $last) {
  my $s = $offset+$limit;
  $next_prev .= "<a href=\"${CGIname}?action=list&offset=${s}&limit=${limit}\">[]</a>";
}
$next_prev .= "</p>\n";

print $next_prev;

for (my $i=0; $i<$numrows; $i++) {
  my($number, $id2, $name, $email, $timestamp, $subject, $content, $del) = @{$res->[$i]};
#  $name = '' if (not $name);
#  $email = '' if (not $email);
  my $f = $del eq 'y' ? 1 : undef ;
  print show_message($number, $id2, $name, $email, $timestamp, $subject, $content, $f);
}

print $next_prev;

print <<EEE;
  </body>
</html>
EEE

$mydb->disconnect;
